--- /tmp/dump_before.txt	2022-10-13 12:30:45.348952516 +0200
+++ /tmp/dump_after.txt	2022-10-13 12:30:32.116860946 +0200
@@ -1,3 +1,39 @@
+                             Table « authentic_dev_publik_love.a2_rbac_operation »
+ Colonne |         Type          | Collationnement | NULL-able |                  Par défaut                   
+---------+-----------------------+-----------------+-----------+-----------------------------------------------
+ id      | integer               |                 | not null  | nextval('a2_rbac_operation_id_seq'::regclass)
+ slug    | character varying(32) |                 | not null  | 
+Index :
+    "a2_rbac_operation_pkey" PRIMARY KEY, btree (id)
+    "a2_rbac_operation_slug_23eb4b87_like" btree (slug varchar_pattern_ops)
+    "a2_rbac_operation_slug_key" UNIQUE CONSTRAINT, btree (slug)
+Référencé par :
+    TABLE "a2_rbac_permission" CONSTRAINT "a2_rbac_permission_operation_id_3ad9aed4_fk_a2_rbac_o" FOREIGN KEY (operation_id) REFERENCES a2_rbac_operation(id) DEFERRABLE INITIALLY DEFERRED
+
+    Séquence « authentic_dev_publik_love.a2_rbac_operation_id_seq »
+  Type   | Début | Minimum |  Maximum   | Incrément | Cycles ? | Cache 
+---------+-------+---------+------------+-----------+----------+-------
+ integer |     1 |       1 | 2147483647 |         1 | no       |     1
+Propriétaire : authentic_dev_publik_love.a2_rbac_operation.id
+
+Index « authentic_dev_publik_love.a2_rbac_operation_pkey »
+ Colonne |  Type   | Clé ? | Définition 
+---------+---------+-------+------------
+ id      | integer | oui   | id
+clé primaire, btree, pour la table « authentic_dev_publik_love.a2_rbac_operation »
+
+Index « authentic_dev_publik_love.a2_rbac_operation_slug_23eb4b87_like »
+ Colonne |         Type          | Clé ? | Définition 
+---------+-----------------------+-------+------------
+ slug    | character varying(32) | oui   | slug
+btree, pour la table « authentic_dev_publik_love.a2_rbac_operation »
+
+Index « authentic_dev_publik_love.a2_rbac_operation_slug_key »
+ Colonne |         Type          | Clé ? | Définition 
+---------+-----------------------+-------+------------
+ slug    | character varying(32) | oui   | slug
+unique, btree, pour la table « authentic_dev_publik_love.a2_rbac_operation »
+
                                            Table « authentic_dev_publik_love.a2_rbac_organizationalunit »
               Colonne               |          Type          | Collationnement | NULL-able |                       Par défaut                       
 ------------------------------------+------------------------+-----------------+-----------+--------------------------------------------------------
@@ -98,19 +134,18 @@
 --------------+---------+-----------------+-----------+------------------------------------------------
  id           | integer |                 | not null  | nextval('a2_rbac_permission_id_seq'::regclass)
  target_id    | integer |                 | not null  | 
- operation_id | integer |                 | not null  | 
  ou_id        | integer |                 |           | 
  target_ct_id | integer |                 | not null  | 
+ operation_id | integer |                 | not null  | 
 Index :
     "a2_rbac_permission_pkey" PRIMARY KEY, btree (id)
-    "a2_rbac_permission_operation_id_3ad9aed4" btree (operation_id)
+    "a2_rbac_permission_operation_new_id_0c34ce1f" btree (operation_id)
     "a2_rbac_permission_ou_id_a68ef755" btree (ou_id)
     "a2_rbac_permission_target_ct_id_519ab0ca" btree (target_ct_id)
-    "null_ou_uniq_idx" UNIQUE, btree (operation_id, target_ct_id, target_id) WHERE ou_id IS NULL
 Contraintes de vérification :
     "a2_rbac_permission_target_id_check" CHECK (target_id >= 0)
 Contraintes de clés étrangères :
-    "a2_rbac_permission_operation_id_3ad9aed4_fk_django_rb" FOREIGN KEY (operation_id) REFERENCES django_rbac_operation(id) DEFERRABLE INITIALLY DEFERRED
+    "a2_rbac_permission_operation_id_3ad9aed4_fk_a2_rbac_o" FOREIGN KEY (operation_id) REFERENCES a2_rbac_operation(id) DEFERRABLE INITIALLY DEFERRED
     "a2_rbac_permission_ou_id_a68ef755_fk_a2_rbac_o" FOREIGN KEY (ou_id) REFERENCES a2_rbac_organizationalunit(id) DEFERRABLE INITIALLY DEFERRED
     "a2_rbac_permission_target_ct_id_519ab0ca_fk_django_co" FOREIGN KEY (target_ct_id) REFERENCES django_content_type(id) DEFERRABLE INITIALLY DEFERRED
 Référencé par :
@@ -122,10 +157,10 @@
  integer |     1 |       1 | 2147483647 |         1 | no       |     1
 Propriétaire : authentic_dev_publik_love.a2_rbac_permission.id
 
-Index « authentic_dev_publik_love.a2_rbac_permission_operation_id_3ad9aed4 »
+Index « authentic_dev_publik_love.a2_rbac_permission_operation_new_id_0c34ce1f »
    Colonne    |  Type   | Clé ? |  Définition  
---------------+---------+-------+--------------
- operation_id | integer | oui   | operation_id
+------------------+---------+-------+--------------
+ operation_new_id | integer | oui   | operation_id
 btree, pour la table « authentic_dev_publik_love.a2_rbac_permission »
 
 Index « authentic_dev_publik_love.a2_rbac_permission_ou_id_a68ef755 »
@@ -2647,42 +2682,6 @@
  id      | integer | oui   | id
 clé primaire, btree, pour la table « authentic_dev_publik_love.django_migrations »
 
-                             Table « authentic_dev_publik_love.django_rbac_operation »
- Colonne |         Type          | Collationnement | NULL-able |                    Par défaut                     
----------+-----------------------+-----------------+-----------+---------------------------------------------------
- id      | integer               |                 | not null  | nextval('django_rbac_operation_id_seq'::regclass)
- slug    | character varying(32) |                 | not null  | 
-Index :
-    "django_rbac_operation_pkey" PRIMARY KEY, btree (id)
-    "django_rbac_operation_slug_7a13d203_like" btree (slug varchar_pattern_ops)
-    "django_rbac_operation_slug_key" UNIQUE CONSTRAINT, btree (slug)
-Référencé par :
-    TABLE "a2_rbac_permission" CONSTRAINT "a2_rbac_permission_operation_id_3ad9aed4_fk_django_rb" FOREIGN KEY (operation_id) REFERENCES django_rbac_operation(id) DEFERRABLE INITIALLY DEFERRED
-
-  Séquence « authentic_dev_publik_love.django_rbac_operation_id_seq »
-  Type   | Début | Minimum |  Maximum   | Incrément | Cycles ? | Cache 
----------+-------+---------+------------+-----------+----------+-------
- integer |     1 |       1 | 2147483647 |         1 | no       |     1
-Propriétaire : authentic_dev_publik_love.django_rbac_operation.id
-
-Index « authentic_dev_publik_love.django_rbac_operation_pkey »
- Colonne |  Type   | Clé ? | Définition 
----------+---------+-------+------------
- id      | integer | oui   | id
-clé primaire, btree, pour la table « authentic_dev_publik_love.django_rbac_operation »
-
-Index « authentic_dev_publik_love.django_rbac_operation_slug_7a13d203_like »
- Colonne |         Type          | Clé ? | Définition 
----------+-----------------------+-------+------------
- slug    | character varying(32) | oui   | slug
-btree, pour la table « authentic_dev_publik_love.django_rbac_operation »
-
-Index « authentic_dev_publik_love.django_rbac_operation_slug_key »
- Colonne |         Type          | Clé ? | Définition 
----------+-----------------------+-------+------------
- slug    | character varying(32) | oui   | slug
-unique, btree, pour la table « authentic_dev_publik_love.django_rbac_operation »
-
                  Table « authentic_dev_publik_love.django_session »
    Colonne    |           Type           | Collationnement | NULL-able | Par défaut 
 --------------+--------------------------+-----------------+-----------+------------
@@ -3040,14 +3039,6 @@
  slug       | character varying(256) | oui   | slug
 unique, btree, pour la table « authentic_dev_publik_love.a2_rbac_role », prédicat (admin_scope_ct_id IS NULL AND ou_id IS NULL)
 
-Index « authentic_dev_publik_love.null_ou_uniq_idx »
-   Colonne    |  Type   | Clé ? |  Définition  
---------------+---------+-------+--------------
- operation_id | integer | oui   | operation_id
- target_ct_id | integer | oui   | target_ct_id
- target_id    | integer | oui   | target_id
-unique, btree, pour la table « authentic_dev_publik_love.a2_rbac_permission », prédicat (ou_id IS NULL)
-
 Index « authentic_dev_publik_love.null_service_name_uniq_idx »
  Colonne |  Type   | Clé ? | Définition 
 ---------+---------+-------+------------