From cacd2bda249dd0ff8d46bbdec05128263ae84c04 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Fr=C3=A9d=C3=A9ric=20P=C3=A9ters?= <fpeters@entrouvert.com>
Date: Mon, 17 Oct 2022 13:02:28 +0200
Subject: [PATCH] misc: remove support for builtin editorial pages (#70338)

---
 MANIFEST.in                 |  1 -
 auquotidien/modules/root.py | 35 -------------------
 setup.py                    |  3 +-
 texts/aq-accessibility.html | 41 ----------------------
 texts/aq-contact.html       |  8 -----
 texts/aq-editor-info.html   | 67 -----------------------------------
 texts/aq-help.html          | 70 -------------------------------------
 7 files changed, 1 insertion(+), 224 deletions(-)
 delete mode 100644 texts/aq-accessibility.html
 delete mode 100644 texts/aq-contact.html
 delete mode 100644 texts/aq-editor-info.html
 delete mode 100644 texts/aq-help.html

diff --git a/MANIFEST.in b/MANIFEST.in
index a6e40ef..9e777e0 100644
--- a/MANIFEST.in
+++ b/MANIFEST.in
@@ -7,5 +7,4 @@ recursive-include apache-errors/ *.html
 recursive-include data/themes/ *.css *.png *.jpeg '*.jpg *.xml *.html *.js *.ezt *.gif *.otf
 recursive-include auquotidien/ *.py
 recursive-include static/ *.png *.jpeg '*.jpg *.js *.gif
-recursive-include texts/ *.html
 recursive-include theme/ *.css *.png *.jpeg '*.jpg *.xml *.html *.js *.ezt *.gif
diff --git a/auquotidien/modules/root.py b/auquotidien/modules/root.py
index e80eeda..945354e 100644
--- a/auquotidien/modules/root.py
+++ b/auquotidien/modules/root.py
@@ -353,10 +353,6 @@ class AlternateRootDirectory(OldRootDirectory):
             # it will get caught in _q_traverse that will redirect it to an
             # URL embedding the category
 
-        if component in ('accessibility', 'contact', 'help'):
-            if TextsDirectory.get_html_text('aq-' + component):
-                return getattr(self, component)()
-
         return None
 
     def json(self):
@@ -623,33 +619,6 @@ class AlternateRootDirectory(OldRootDirectory):
         r += htmltext('</div>')
         return r.getvalue()
 
-    def page_view(self, key, title, urlname=None):
-        if not urlname:
-            urlname = key[3:].replace(str('_'), str('-'))
-        get_response().breadcrumb.append((urlname, title))
-        template.html_top(title)
-        r = TemplateIO(html=True)
-        r += htmltext('<div class="article">')
-        r += htmltext(TextsDirectory.get_html_text(key))
-        r += htmltext('</div>')
-        return r.getvalue()
-
-    def informations_editeur(self):
-        get_response().filter['bigdiv'] = 'info'
-        return self.page_view('aq-editor-info', _('Editor Informations'), urlname='informations_editeur')
-
-    def accessibility(self):
-        get_response().filter['bigdiv'] = 'accessibility'
-        return self.page_view('aq-accessibility', _('Accessibility Statement'))
-
-    def contact(self):
-        get_response().filter['bigdiv'] = 'contact'
-        return self.page_view('aq-contact', _('Contact'))
-
-    def help(self):
-        get_response().filter['bigdiv'] = 'help'
-        return self.page_view('aq-help', _('Help'))
-
 
 from qommon.publisher import get_publisher_class
 
@@ -658,10 +627,6 @@ get_publisher_class().after_login_url = 'myspace/'
 get_publisher_class().use_sms_feature = True
 
 
-TextsDirectory.register('aq-editor-info', N_('Editor Informations'))
-TextsDirectory.register('aq-accessibility', N_('Accessibility Statement'))
-TextsDirectory.register('aq-contact', N_('Contact Information'))
-TextsDirectory.register('aq-help', N_('Help'))
 TextsDirectory.register(
     'aq-sso-text',
     N_('Connecting with Identity Provider'),
diff --git a/setup.py b/setup.py
index 9eda6ef..7f975b2 100644
--- a/setup.py
+++ b/setup.py
@@ -115,8 +115,7 @@ setup(
         'sdist': eo_sdist,
     },
     include_package_data=True,
-    data_files=data_tree('share/wcs/texts', 'texts')
-    + data_tree('share/wcs/themes/auquotidien', 'theme')
+    data_files=data_tree('share/wcs/themes/auquotidien', 'theme')
     + data_tree('share/wcs/themes/', 'data/themes/')
     + data_tree('share/auquotidien/apache-errors', 'apache-errors')
     + [
diff --git a/texts/aq-accessibility.html b/texts/aq-accessibility.html
deleted file mode 100644
index b0cf845..0000000
--- a/texts/aq-accessibility.html
+++ /dev/null
@@ -1,41 +0,0 @@
-<p>En f&eacute;vrier 2006 la <a
-href="http://www.assemblee-nationale.fr/12/ta/ta0307.asp">loi sur l'&eacute;galit&eacute; des
-droits et des chances, la participation et la citoyennet&eacute; des personnes
-handicap&eacute;es</a> a &eacute;t&eacute; un pas important en faveur du d&eacute;veloppement du Web, en
-raison de l'obligation d'accessibilit&eacute; qu'elle entra&icirc;ne pour les services en
-ligne de l'&Eacute;tat.</p>
-
-<p>Cependant, les b&eacute;n&eacute;fices de l'accessibilit&eacute; num&eacute;rique d&eacute;passent de tr&egrave;s loin
-les seuls champs du handicap et des services publics.</p>
-
-<p>En respectant les standards d'accessibilit&eacute;, les &eacute;diteurs de sites
-fournissent un contenu et des services &agrave; l'ensemble des publics et laissent ces
-publics afficher, repr&eacute;senter ou &eacute;noncer ces contenus en fonction de leur
-configuration et de leurs comp&eacute;tences sp&eacute;cifiques. Cela permet de garantir une
-v&eacute;ritable interop&eacute;rabilit&eacute;, pr&eacute;vient la mise en captivit&eacute; des contenus par une
-technologie propri&eacute;taire quelconque.</p>
-
-<h3>Touches d'acc&egrave;s</h3>
-
-<p>La plupart des navigateurs permettent d'aller directement sur un lien
-sp&eacute;cifique en tapant une touche d&eacute;finies par le site web.  Sous Windows, vous
-pouvez utiliser ALT + touche d'acc&egrave;s; sous Macintosh, vous pouvez utiliser
-Control + touche d'acc&egrave;s.</p>
-
-<p>Les touches d'acc&egrave;s suivantes sont d&eacute;finies sur toutes les pages du
-site&nbsp;:</p>
-
-<ul>
-<li>Touche d'acc&egrave;s 1: page d'accueil</li>
-<li>Touche d'acc&egrave;s 9: page de contact</li>
-<li>Touche d'acc&egrave;s 0: d&eacute;claration d'accessibilit&eacute;</li>
-</ul>
-
-<h3>Conformit&eacute; aux standards</h3>
-
-<p>L'ensemble des pages que nous produisons respecte les normes recommand&eacute;es
-par le W3C, &agrave; savoir les sp&eacute;cifications xhtml 1.0 et CSS qui permettent une
-totale s&eacute;paration du contenu et de la pr&eacute;sentation &agrave; l'&eacute;cran ou &agrave; l'impression,
-ainsi que <a href="http://www.w3.org/WAI/">WAI</a> la norme r&eacute;f&eacute;rence en
-mati&egrave;re d'accessibilit&eacute;.</p>
-
diff --git a/texts/aq-contact.html b/texts/aq-contact.html
deleted file mode 100644
index 7018ff3..0000000
--- a/texts/aq-contact.html
+++ /dev/null
@@ -1,8 +0,0 @@
-<p>Entr'ouvert, 44-46 rue de l'Ouest - 75014 Paris</p>
-
-<p>T&eacute;l. : +33 (0)1 43 35 01 35</p>
-
-<p>Fax : +33 (0)1 43 35 00 76</p>
-
-<p>Courriel : <a href="mailto:info&#64;entrouvert.com">info&#64;entrouvert.com</a></p>
-
diff --git a/texts/aq-editor-info.html b/texts/aq-editor-info.html
deleted file mode 100644
index 828c398..0000000
--- a/texts/aq-editor-info.html
+++ /dev/null
@@ -1,67 +0,0 @@
-<p>Site de d&eacute;monstration de l'offre "Au quotidien" d'Entr'ouvert,
-r&eacute;alis&eacute; par Fr&eacute;d&eacute;ric P&eacute;ters.</p>
-
-<p>Directeur de la publication : XXX</p>
-<p>Responsable du site : XXX</p>
-<p>R&eacute;daction : XXX</p>
-<p>Photos : XXX</p>
-<p>&Eacute;diteur : Entr'ouvert - 44-46 rue de l'Ouest - 75015 Paris</p>
-
-<h3>Informatique et libert&eacute;s</h3>
-
-<p>Les liens hypertexte pr&eacute;sents sur le site et aiguillant les utilisateurs
-vers d'autres sites Internet n'engagent pas la responsabilit&eacute; de la r&eacute;daction
-du site quant au contenu de ces sites.</p>
-
-<p>Lorsque des donn&eacute;es pr&eacute;sentes sur ce site ont un caract&egrave;re nominatif, les
-utilisateurs doivent en faire un usage conforme aux r&eacute;glementations en vigueur
-et aux recommandations de la Commission nationale de l'informatique et des
-libert&eacute;s (CNIL).</p>
-
-<p>Les informations utilis&eacute;es ne doivent l'&ecirc;tre qu'&agrave; des fins personnelles,
-associatives ou professionnelles, toute diffusion ou utilisation &agrave; des fins
-commerciales ou publicitaires &eacute;tant exclues.</p>
-
-<p>Conform&eacute;ment &agrave; la loi fran&ccedil;aise (article 27 de la Loi n&deg; 78.17 du 6 janvier
-1978 relative &agrave; l'informatique, aux fichiers et aux libert&eacute;s), vous disposez
-d'un droit d'opposition (art. 26) d'acc&egrave;s (art. 34 &agrave; 38), de rectification
-(art. 36) et de suppression des donn&eacute;es qui vous concernent. Vous pouvez
-exercer ce droit en vous adressant aupr&egrave;s de:</p>
-
-<div class="address">
-Entr'ouvert<br />
-44-46 rue de l'Ouest<br />
-75015 Paris<br />
-</div>
-
-<p>Ce site est enregistr&eacute; aupr&egrave;s de la Commission Nationale de l'Informatique
-et des Libert&eacute;s sous le dossier n&deg; XXX.</p>
-
-<h3>Droits d'auteur et/ou Droits sur les dessins, photos et textes</h3>
-
-<p>Le pr&eacute;sent site constitue une oeuvre dont la "Entr'ouvert" est
-l'auteur au sens des articles L. 111.1 et suivants du Code de la propri&eacute;t&eacute;
-intellectuelle.</p>
-
-<p>Les photographies, textes, slogans, dessins, images, s&eacute;quences anim&eacute;es
-sonores ou non ainsi que toutes oeuvres int&eacute;gr&eacute;s dans le site sont la propri&eacute;t&eacute;
-de "Entr'ouvert" ou de tiers ayant autoris&eacute; "Entr'ouvert" &agrave;
-les utiliser.</p>
-
-<p>Les logos, ic&ocirc;nes et puces graphiques repr&eacute;sent&eacute;s sur le site sont prot&eacute;g&eacute;s
-au titre des droits d'auteur et des articles L.511.1 et suivants du Code de la
-propri&eacute;t&eacute; intellectuelle relatifs &agrave; la protection des mod&egrave;les d&eacute;pos&eacute;s.</p>
-
-<p>Les reproductions, sur un support papier ou informatique, dudit site et des
-oeuvres qui y sont reproduits sont autoris&eacute;es sous r&eacute;serve qu'elles soient
-strictement r&eacute;serv&eacute;es &agrave; un usage personnel excluant tout usage &agrave; des fins
-publicitaires et/ou commerciales et/ou d'information et/ou qu'elles soient
-conformes aux dispositions de l'article L122-5 du Code de la Propri&eacute;t&eacute;
-Intellectuelle.</p>
-
-<p>&Agrave; l'exception des dispositions ci-dessus, toute reproduction,
-repr&eacute;sentation, utilisation ou modification, par quelque proc&eacute;d&eacute; que ce soit et
-sur quelque support que ce soit, de tout ou partie du site, de tout ou partie
-des diff&eacute;rentes oeuvres qui le composent, sans avoir obtenu l'autorisation
-pr&eacute;alable d'Entr'ouvert, est strictement interdite et constitue un d&eacute;lit de
-contrefa&ccedil;on.</p>
diff --git a/texts/aq-help.html b/texts/aq-help.html
deleted file mode 100644
index bd0510a..0000000
--- a/texts/aq-help.html
+++ /dev/null
@@ -1,70 +0,0 @@
-<h3>Liens utiles : pour vous informer</h3>
-
-<p>Les liens utiles sont des liens externes &agrave; "Ma ville au
-quotidien". Ils envoient vers des informations pertinentes concernant
-notre cit&eacute;.</p>
-
-<p>Lorsque vous &ecirc;tes sur le site d'un lien, utilisez la touche de retour de
-votre navigateur pour revenir sur "Ma ville au quotidien".</p>
-
-<p>Les liens propos&eacute;s sont communiqu&eacute;s &agrave; titre indicatif et ne sauraient
-engager la responsabilit&eacute; de la soci&eacute;t&eacute; &eacute;ditrice de "Ma ville au
-quotidien", tant en ce qui concerne les contenus que les conditions
-d'acc&egrave;s.</p>
-
-<h3>Services : pour faciliter vos d&eacute;marches</h3>
-
-<p>La rubrique "Services" vous propose des t&eacute;l&eacute;formulaires destin&eacute;s &agrave;
-faciliter vos d&eacute;marches les plus courantes.</p>
-
-<p>Les t&eacute;l&eacute;formulaires sont class&eacute;s par cat&eacute;gories et vous permettent
-d'accomplir sans vous d&eacute;placer les  principales d&eacute;marches du quotidien.</p>
-
-<p>Les champs de formulaire disposent d'exemples destin&eacute;s &agrave; vous faciliter le
-remplissage.</p>
-
-<p>Les r&eacute;ponses &agrave; caract&egrave;re obligatoire sont suivies d'un carr&eacute; rouge.</p>
-
-<p>Le nom du service charg&eacute; du traitement de votre demande figure au d&eacute;but de
-chaque formulaire.</p>
-
-<p>L'agent charg&eacute; du traitement re&ccedil;oit un courriel de notification &agrave; chaque
-nouvelle demande.</p>
-
-<p>Lors de l'avancement de votre demande, vous &ecirc;tes averti par courriel de
-chacune des &eacute;tapes du traitement.</p>
-
-<h3>Consultations : pour vous exprimer</h3>
-
-<p>Les consultations sont destin&eacute;es &agrave; recueillir, de mani&egrave;re anonyme, votre
-avis sur des sujets g&eacute;n&eacute;raux.</p>
-
-<p>Il ne s'agit pas de vote, mais pl&ucirc;tot de sondages destiner &agrave; nous aider dans
-la prise de d&eacute;cision.</p>
-
-<p>Certaines questions disposent d'aide sp&eacute;cifique pour certains champs.</p>
-
-<h3>Annonces aux citoyens : pour vous avertir</h3>
-
-<p>Les annonces nous permettent &agrave; votre demande de vous avertir d'&eacute;v&egrave;nements en
-rapport avec la vie de notre cit&eacute;, par exemple de ph&eacute;nom&egrave;nes m&eacute;t&eacute;orologiques
-(grands froids, canicule, crues), de manifestations sportives ou
-culturelles.</p>
-
-<p>Vous pouvez au choix recevoir les annonces de 3 fa&ccedil;ons :</p>
-
-<ul>
-<li>par SMS</li>
-<li>par courriel</li>
-<li>ou par Atom (le standard Atom permet la diffusion d'actualit&eacute;s sur internet
-les nouvelles sont lues gr&acirc;ce &agrave; un lecteur sp&eacute;cifique sur votre ordinateur ou
-directement dans sur aggr&eacute;gateur de nouvelles, sur internet).</li>
-</ul>
-
-<p>Pour vous abonner aux annonces par courriel ou SMS, il vous suffit soit de
-nous communiquer une adresse &eacute;lectronique, soit un num&eacute;ro de t&eacute;l&eacute;phone
-portable.</p>
-
-<p>Pour recevoir les annonces par fil Atom, il vous suffit de copier d'adresse
-du flux dans votre lecteur (navigateur ou aggr&eacute;gateur sur internet).</p>
-
-- 
2.37.2