From e533e5c23040ba23245a505c03d7dc759e34452e Mon Sep 17 00:00:00 2001
From: Paul Marillonnet <pmarillonnet@entrouvert.com>
Date: Mon, 17 Oct 2022 17:12:49 +0200
Subject: [PATCH] leplessistrevise: bring minor fixes to theme (#70365)

---
 static/leplessistrevise/_custom.scss | 144 ++++++++++++++++++++++++---
 static/leplessistrevise/_vars.scss   |  12 ++-
 2 files changed, 136 insertions(+), 20 deletions(-)

diff --git a/static/leplessistrevise/_custom.scss b/static/leplessistrevise/_custom.scss
index d17d6606..f8a27463 100644
--- a/static/leplessistrevise/_custom.scss
+++ b/static/leplessistrevise/_custom.scss
@@ -8,9 +8,20 @@
 	min-height: 120px;
 	@media screen and (max-width: $mobile-limit) {
 		padding-top: 40px;
+		min-width: 240px;
 	}
 }
 
+#toplinks {
+	box-shadow: none;
+	text-transform: uppercase;
+	a {
+		color: $tertiary-color;
+		font-weight: bold;
+	}
+}
+
+
 //
 //	NAV
 //
@@ -60,9 +71,23 @@ div#nav {
 	}
 	@media screen and (max-width: $mobile-limit) {
 		padding-top: 10px;
-		button.gru-nav-button {
+		button.gru-nav-button, ul.menu, ul.menu:before {
 			background: $secondary-color;
 		}
+		.icon-bar {
+			background-color: white;
+		}
+		ul li {
+			border-bottom: 2px solid #9bd600;
+		}
+		ul li > a {
+			color: white;
+			&:hover { color: $tertiary-color; }
+		}
+		ul li.selected > a {
+			background: $tertiary-color;
+			&:hover { color: white; }
+		}
 	}
 }
 
@@ -70,8 +95,27 @@ div#nav {
 //	MAIN CONTENT
 //
 
-%button:hover {
-	border: 3px solid #6598cd;
+%button {
+	text-transform: uppercase;
+	font-weight: bold;
+	&:hover {
+		border: 3px solid #6598cd;
+		box-shadow: none;
+	}
+}
+
+div.cell.pk-error {
+	border-left: 4px solid rgba(10,10,10,.32);
+	border-right: 4px solid rgba(10,10,10,.32);
+}
+
+#messages {
+	li.success::before,
+	li.info::before,
+	li.warning::before,
+	li.error::before {
+		top: 0em;
+	}
 }
 
 main {
@@ -103,16 +147,15 @@ main {
 
 div.searchcell form input {
 	margin-right: 0px;
-	border-radius: 10px 0px 0px 0px;
+	border-radius: 5px;
 }
 
 button.combo-search--button {
 	background-color: #e8b200;
-	border: 1px solid #e2e1e0;
-	border-radius: 0px 0px 10px 0px;
+	border: 3px solid #e8b200;
+	border-radius: 10px 0px 10px 0px;
 	&:hover {
-		background-color: darken(#e8b200, 5%);
-		border: 1px solid #e2e1e0;
+		border: 3px solid #fbe7a6;
 	}
 }
 
@@ -120,28 +163,98 @@ div.wcsformsofcategorycell {
 	picture img {
 		width: 100%;
 	}
+	ul > li {
+		line-height: 1;
+		&:not(:last-child) {
+			border: 1px dotted #e2e1e0;
+		}
+	}
+	&.has-asset-picture > div picture img {
+		border-radius: 15px 0px 0px 0px;
+	}
 }
 
+
 div.wcs-form-cell {
 	padding: 1em;
 }
 
-.gru-content div.wcsformsofcategorycell.has-asset-picture > div picture img {
-	border-radius: $cell-border-radius;
-}
-
 div#rub_service {
 	background: darken(white, 3%);
 	border-radius: $cell-border-radius;
 	h3 { color: $primary-color; }
+	&.form-content--body {
+		border: 1px solid #e2e1e0;
+		h3 {
+			text-transform: uppercase;
+		}
+		span.required {
+			color: $tertiary-color;
+		}
+		div.hint {
+			font-style: italic;
+		}
+		button.form-previous, button.form-next, button.form-submit {
+			background: $tertiary-color;
+			border: 3px solid $tertiary-color;
+			&:hover {
+				border: 3px solid #b76d74;
+			}
+		}
+	}
+}
+
+div#rub_service div.timetable-widget {
+	div.head {
+		font-weight: bold;
+	}
+	span.timetable-cell {
+		border-radius: 5px;
+	}
+	button.next {
+		background: $tertiary-color;
+		border: 3px solid $tertiary-color;
+		&:hover {
+			border: 3px solid #b76d74;
+			box-shadow: none;
+		}
+	}
+}
+
+.form-content--title {
+	font-size: 25px;
 }
 
 div#tracking-code h3 {
 	font-size: 130%;
-	text-transform: none;
+	text-transform: uppercase;
 	color: $secondary-color;
 }
 
+div.wcs-tracking-code-input button {
+	background: $tertiary-color;
+	border: 3px solid $tertiary-color;
+	&:hover {
+		background: $tertiary-color;
+		border: 3px solid #b76d74;
+	}
+}
+
+.pwa-navigation div > ul li a,
+.pwa-navigation div#nav ul li a {
+	& > span {
+		font-size: 1em;
+	}
+	color: white;
+	background: $secondary-color;
+	width: 100%;
+	height: 100%;
+}
+
+.wcs-step.current {
+	border-bottom: 2px solid $primary-color;
+}
+
 @media (min-width: $mobile-limit + 1) {
 	div.form-content--sidebox div#side header#steps ol li:first-child {
 		border-radius: 15px 0px 0px 0px;
@@ -161,8 +274,9 @@ div#tracking-code h3 {
 		background-size: contain;
 		text-indent: -10000px;
 		display: block;
-		min-width: 165px;
-		min-height: 124px;
+		min-height: 90px;
+		margin-top: 1em;
+		margin-left: 1em;
 	}
 	.site-info__address {
 		margin-left: 15px;
diff --git a/static/leplessistrevise/_vars.scss b/static/leplessistrevise/_vars.scss
index 476bd1bb..2f1070f1 100644
--- a/static/leplessistrevise/_vars.scss
+++ b/static/leplessistrevise/_vars.scss
@@ -1,5 +1,6 @@
 $primary-color: #236bb7;
 $secondary-color: #3c8703;
+$tertiary-color: #b53845;
 
 $font-color: black;
 $font-family: 'Rubik', sans-serif;
@@ -33,8 +34,9 @@ $header-full-width-background: false;
 
 $button-color: white;
 $button-background: #236bb7;
-$button-border-radius: 10px 0px 10px 0px;
+$button-border-radius: 5px;
 $button-border: 3px solid #236bb7;
+$buttons-order: cancel (grow), previous, submit;
 
 $footer-background: $primary-color;
 $footer-color: white;
@@ -53,21 +55,21 @@ $title-border-radius: 0px;
 
 $widget-border: 1px solid #e2e1e0;
 $widget-focus-border: 1px solid $primary-color;
-$widget-border-radius: 2px;
+$widget-border-radius: 5px;
 $widget-background: white;
 
-$wcs-step-current-background: darken($primary-color, 10%);
+$wcs-step-current-background: $primary-color;
 $wcs-step-current-color: white;
 $wcs-step-color: grey;
 $wcs-step-background: darken(#f6f5f4, 3%);
-$wcs-step-border-bottom: 2px solid grey;
+$wcs-step-border-bottom: 2px solid $tertiary-color;
 
 $cell-background: #f6f5f4;
 $cell-title-cover-border: false;
 $cell-entry-color: $font-color;
 $cell-entry-hover-color: #444444;
 $cell-entry-hover-background: #f8f8f8;
-$cell-border: 2px solid #e2e1e0;
+$cell-border: 1px solid #e2e1e0;
 $cell-border-radius: 15px 0px 15px 0px;
 $cell-image-position: top;
 $cell-image-padding: none;
-- 
2.37.2